# mypy-boto3-fsx

[![PyPI - mypy-boto3-fsx](https://img.shields.io/pypi/v/mypy-boto3-fsx.svg?color=blue)](https://pypi.org/project/mypy-boto3-fsx)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-fsx.svg?color=blue)](https://pypi.org/project/mypy-boto3-fsx)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-fsx](#mypy-boto3-fsx)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.FSx 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/fsx.html#FSx) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-fsx](#mypy-boto3-fsx)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `FSx` service.

```bash
python -m pip install boto3-stubs[fsx]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_fsx` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_fsx import FSxClient

# Now mypy can check if your code is valid.
client: FSxClient = boto3.client("fsx")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: FSxClient = session.client("fsx")



# Annotated paginators are included as well

import mypy_boto3_fsx.paginator as fsx_paginators

describe_backups_paginator: fsx_paginators.DescribeBackupsPaginator = client.get_paginator("describe_backups")
describe_file_systems_paginator: fsx_paginators.DescribeFileSystemsPaginator = client.get_paginator("describe_file_systems")
list_tags_for_resource_paginator: fsx_paginators.ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_fsx` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_fsx as fsx
from mypy_boto3_fsx import FSxClient

# with these
from mypy_boto3 import fsx
from mypy_boto3.fsx import FSxClient
```